'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var fetch = _interopDefault(require('node-fetch'));
var $ = _interopDefault(require('cheerio'));
var url = _interopDefault(require('url'));
var FormData = _interopDefault(require('form-data'));
var vm = require('vm');
var toughCookie = require('tough-cookie');
var TempMail = require('temp-mail');
var TempMail__default = TempMail['default'];
var debug = _interopDefault(require('debug'));
var fs = _interopDefault(require('fs'));
var child = _interopDefault(require('child_process'));
var path = _interopDefault(require('path'));
var stream = require('stream');
var os = _interopDefault(require('os'));

function cheerio(options) {
	return function (req) {
		return req.text().then(function (body) {
			return $.load(body, options);
		});
	};
}

var ANONIMITY_LEVELS = ['transparent', 'anonymous', 'elite proxy'];

function scrap() {
	return fetch('http://www.free-proxy-list.net').then(cheerio()).then(function ($$$1) {
		return $$$1('#proxylisttable > tbody > tr').map(function (i, e) {
			var element = $$$1(e).find('td');
			var ip = element.eq(0).text();
			var port = element.eq(1).text();
			var country = element.eq(3).text().toUpperCase();
			var anonymity = ANONIMITY_LEVELS.indexOf(element.eq(4).text());
			var type = element.eq(5).text() == 'yes' ? 'https' : 'http';
			return { ip: ip, port: port, country: country, anonymity: anonymity, type: type };
		}).get();
	});
}

var classCallCheck = function (instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
};

var createClass = function () {
  function defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  return function (Constructor, protoProps, staticProps) {
    if (protoProps) defineProperties(Constructor.prototype, protoProps);
    if (staticProps) defineProperties(Constructor, staticProps);
    return Constructor;
  };
}();



























var slicedToArray = function () {
  function sliceIterator(arr, i) {
    var _arr = [];
    var _n = true;
    var _d = false;
    var _e = undefined;

    try {
      for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
        _arr.push(_s.value);

        if (i && _arr.length === i) break;
      }
    } catch (err) {
      _d = true;
      _e = err;
    } finally {
      try {
        if (!_n && _i["return"]) _i["return"]();
      } finally {
        if (_d) throw _e;
      }
    }

    return _arr;
  }

  return function (arr, i) {
    if (Array.isArray(arr)) {
      return arr;
    } else if (Symbol.iterator in Object(arr)) {
      return sliceIterator(arr, i);
    } else {
      throw new TypeError("Invalid attempt to destructure non-iterable instance");
    }
  };
}();

function createTextScraper(url$$1) {
	return function scrap() {
		return fetch(url$$1).then(function (res) {
			return res.text();
		}).then(function (text) {
			return extractProxies(text);
		});
	};
}

function extractProxies(text) {
	var data = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

	return text.split('\n').map(function (proxy) {
		return proxy.split(':');
	}).map(function (_ref) {
		var _ref2 = slicedToArray(_ref, 2),
		    ip = _ref2[0],
		    port = _ref2[1];

		return Object.assign({ ip: ip, port: parseInt(port) }, data);
	});
}

var Session = function () {
	function Session(fetch$$1) {
		classCallCheck(this, Session);

		this.jar = new toughCookie.CookieJar();
		this._fetch = fetch$$1;
	}

	createClass(Session, [{
		key: 'fetch',
		value: function fetch$$1(url$$1) {
			var _this = this;

			var opts = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

			return this.getCookies(url$$1).then(function (cookies) {
				return _this._fetch(url$$1, Object.assign(opts, {
					headers: Object.assign(opts.headers || {}, {
						cookie: cookies.join('; ')
					})
				})).then(function (res) {
					var cookies = res.headers.get('set-cookie');
					cookies = cookies && cookies.split(',') || [];
					cookies.map(function (cookie) {
						return _this.jar.setCookie(cookie, url$$1, function () {
							return null;
						});
					});
					return res;
				});
			});
		}
	}, {
		key: 'getCookies',
		value: function getCookies(url$$1) {
			var _this2 = this;

			return new Promise(function (resolve, reject) {
				_this2.jar.getCookies(url$$1, function (err, cookies) {
					if (err) reject(err);else resolve(cookies);
				});
			});
		}
	}]);
	return Session;
}();

var log$2 = debug('proxy-scraper:temp-mail');

var NOOP = function NOOP() {};

function poll(email) {
	var interval = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 5000;
	var iterations = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 20;

	return new Promise(function (resolve, reject) {
		var count = 0;
		var id = setInterval(function () {
			if (count < iterations) {
				count++;
				log$2('Polling inbox for mail %s iteration %d, max: %d', email, count, iterations);
				TempMail__default.getInbox(email).then(function (mails) {
					resolve(mails);
					clearInterval(id);
				}).catch(NOOP); //Ignore Error
			} else {
				clearInterval(id);
				reject(new Error('Timeout exceeded, no messages found.'));
			}
		}, interval);
	});
}

var log$1 = debug('proxy-scraper:gatherproxy.com');

var CAPTCHA_REPLACE = {
	multiplied: '*',
	plus: '+',
	minus: '-',
	x: '*',
	zero: 0,
	one: 1,
	two: 2,
	three: 3,
	four: 4,
	five: 5,
	six: 6,
	seven: 7,
	eight: 8,
	nine: 9
};

var ANONIMITY_LEVELS$1 = ['transparent', 'anonymous', 'elite'];

function scrap$1() {
	var session = new Session(fetch);
	var fetch$$1 = function fetch$$1(url$$1, options) {
		return session.fetch(url$$1, options);
	};
	return getAccount(fetch$$1).then(function () {
		var chain = Promise.resolve([]);

		var _loop = function _loop(level) {
			chain = chain.then(function (data) {
				return getProxyListId(fetch$$1, level).then(function (id) {
					return downloadProxyList(fetch$$1, level, id);
				}).then(function (text) {
					return data.push(extractProxies(text, {
						anonimity: ANONIMITY_LEVELS$1.indexOf(level)
					}));
				}).then(function () {
					return data;
				});
			});
		};

		var _iteratorNormalCompletion = true;
		var _didIteratorError = false;
		var _iteratorError = undefined;

		try {
			for (var _iterator = ANONIMITY_LEVELS$1[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
				var level = _step.value;

				_loop(level);
			}
		} catch (err) {
			_didIteratorError = true;
			_iteratorError = err;
		} finally {
			try {
				if (!_iteratorNormalCompletion && _iterator.return) {
					_iterator.return();
				}
			} finally {
				if (_didIteratorError) {
					throw _iteratorError;
				}
			}
		}

		return chain.then(function (datas) {
			return datas.reduce(function (prev, next) {
				return prev.concat(next);
			}, []);
		});
	});
}

function getAccount(fetch$$1) {
	return loadAccountFromCache().then(function (_ref) {
		var email = _ref.email,
		    password = _ref.password;

		log$1('Loaded account with email %s and password %s from .gatherproxy.account', email, password);
		return login(fetch$$1, email, password);
	}).catch(function () {
		log$1('Invalid account in .gatherproxy.account, creating new one');
		return createAccount(fetch$$1).then(function (_ref2) {
			var email = _ref2.email,
			    password = _ref2.password;

			log$1('Storing account with email %s and password %s in .gatherproxy.account', email, password);
			return storeAccountToCache(email, password).catch(function () {
				return {
					email: email,
					password: password
				};
			});
		}).then(function (_ref3) {
			var email = _ref3.email,
			    password = _ref3.password;
			return login(fetch$$1, email, password);
		});
	});
}

function loadAccountFromCache() {
	return new Promise(function (resolve, reject) {
		fs.readFile('./.gatherproxy.account', 'utf8', function (err, data) {
			if (err) reject(err);else resolve(JSON.parse(data));
		});
	});
}

function storeAccountToCache(email, password) {
	return new Promise(function (resolve, reject) {
		fs.writeFile('./.gatherproxy.account', JSON.stringify({ email: email, password: password }), function (err) {
			if (err) reject(err);else resolve({ email: email, password: password });
		});
	});
}

function createAccount(fetch$$1) {
	var email = Math.random().toString(36).substring(7) + '@doanart.com'; //@binka.me don't receive email
	log$1('Creating account with email %s', email);
	var form = new FormData();
	form.append('email', email);
	return fetch$$1('http://www.gatherproxy.com/subscribe', {
		method: 'POST',
		body: form,
		headers: form.getHeaders()
	}).then(function () {
		return poll(email);
	}).then(function (_ref4) {
		var _ref5 = slicedToArray(_ref4, 1),
		    mail_text_only = _ref5[0].mail_text_only;

		return (/<p>Password: (.*)<\/p>/.exec(mail_text_only)[1]
		);
	}).then(function (password) {
		log$1('Account %s with password %s created', email, password);
		return { email: email, password: password };
	});
}

function login(fetch$$1, email, password) {
	log$1('Logging in with email %s and password %s', email, password);
	return fetch$$1('http://www.gatherproxy.com/subscribe/login').then(cheerio()).then(function ($$$1) {
		var captcha = $$$1('#body > form > .label > .blue').first().text();

		var form = new FormData();
		form.append('Username', email);
		form.append('Password', password);
		form.append('Captcha', solveCaptcha(captcha));

		return fetch$$1('http://www.gatherproxy.com/subscribe/login', {
			method: 'POST',
			body: form,
			headers: form.getHeaders()
		});
	});
}

function solveCaptcha(raw) {
	var captcha = raw.split(' ').map(function (part) {
		return part.toLowerCase();
	}).map(function (part) {
		return part in CAPTCHA_REPLACE ? CAPTCHA_REPLACE[part] : part;
	});

	captcha.splice(captcha.indexOf('='), 1); // Remove the =

	var c = captcha.join(' ');
	var result = new vm.Script(c).runInNewContext({});

	log$1('Captcha %s (raw: %s) solved, result: %d', c, raw, result);
	return result;
}

function getProxyListId(fetch$$1, anonimity) {
	log$1('Getting id for anonimity %s', anonimity);
	var form = new FormData();
	form.append('Uptime', 0);
	form.append('Type', anonimity);
	return fetch$$1('http://www.gatherproxy.com/proxylist/anonymityplaintext', {
		method: 'POST',
		body: form,
		headers: form.getHeaders(),
		redirect: 'manual'
	}).then(function (res) {
		return url.parse(res.headers.get('location'), true).query.sid;
	});
}

function downloadProxyList(fetch$$1, anonimity, id) {
	log$1('Downloading proxy with anonimity %s using id %s', anonimity, id);
	var form = new FormData();
	form.append('ID', id);
	form.append('T', anonimity);
	return fetch$$1('http://www.gatherproxy.com/proxylist/downloadproxylist/', {
		method: 'POST',
		body: form,
		headers: form.getHeaders()
	}).then(function (res) {
		return res.text();
	});
}

var maxtime = 1000;

function scrap$2() {
	return fetch('https://hidemy.name/en/proxy-list/?maxtime=' + maxtime + '&type=hs', {
		headers: {
			'User-Agent': 'Mozilla/5.0'
		}
	}).then(cheerio()).then(function ($$$1) {
		return $$$1('.proxy__t > tbody > tr').map(function (i, e) {
			var element = $$$1(e).find('td');
			var ip = $$$1(element).find('td').eq(0).text();
			var port = $$$1(element).find('td').eq(1).text();
			return { ip: ip, port: port };
		}).get();
	});
}

var ANONIMITY_LEVELS$2 = ['transparent', 'anonymous', 'elite'];

function scrap$3(types) {
	return fetch('https://hidester.com/proxydata/php/data.php?mykey=csv&gproxy=2', {
		headers: {
			Referer: 'https://hidester.com/proxylist/'
		}
	}).then(function (req) {
		return req.json();
	}).then(function (datas) {
		return datas.map(function (_ref) {
			var ip = _ref.IP,
			    port = _ref.PORT,
			    type = _ref.type,
			    country = _ref.country,
			    anonymity = _ref.anonymity;
			return {
				ip: ip,
				port: port,
				type: type,
				country: country,
				anonimity: ANONIMITY_LEVELS$2.indexOf(anonymity.toLowerCase())
			};
		});
	});
}

var multiproxy = createTextScraper('http://multiproxy.org/txt_all/proxy.txt');

function scrap$4() {
	var session = new Session(fetch);

	return session.fetch('https://nordvpn.com/free-proxy-list/').then(function () {
		return session.fetch('https://nordvpn.com/wp-admin/admin-ajax.php?searchParameters%5B0%5D%5Bname%5D=proxy-country&searchParameters%5B0%5D%5Bvalue%5D=&searchParameters%5B1%5D%5Bname%5D=proxy-ports&searchParameters%5B1%5D%5Bvalue%5D=&offset=0&limit=100000&action=getProxies', {
			method: 'POST'
		});
	}).then(function (res) {
		return res.json();
	}).then(function (datas) {
		return datas.map(function (_ref) {
			var ip = _ref.ip,
			    port = _ref.port,
			    country = _ref.country,
			    type = _ref.type;
			return {
				ip: ip,
				port: port,
				country: country,
				type: type.toLowerCase()
			};
		});
	});
}

var SOURCES = [{
	url: 'http://proxyserverlist-24.blogspot.fr/',
	type: 'http',
	selector: '.post-body > pre > span > span:nth-child(2)'
}, {
	url: 'http://sslproxies24.blogspot.fr/',
	type: 'https',
	selector: '.post-body > pre > span > span'
}, {
	url: 'http://vip-socks24.blogspot.com/',
	type: 'socks5',
	selector: '.post-body > textarea'
}];

function scrap$5() {
	var result = [];

	var _loop = function _loop(source) {
		result.push(fetch(source.url).then(cheerio()).then(function ($$$1) {
			return $$$1('.post-title > a').eq(0).attr('href');
		}) //Only take first
		.then(function (url$$1) {
			return fetch(url$$1);
		}).then(cheerio()).then(function ($$$1) {
			return $$$1(source.selector).eq(0).text();
		}).then(function (proxies) {
			return extractProxies(proxies, { type: source.type });
		}));
	};

	var _iteratorNormalCompletion = true;
	var _didIteratorError = false;
	var _iteratorError = undefined;

	try {
		for (var _iterator = SOURCES[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
			var source = _step.value;

			_loop(source);
		}
	} catch (err) {
		_didIteratorError = true;
		_iteratorError = err;
	} finally {
		try {
			if (!_iteratorNormalCompletion && _iterator.return) {
				_iterator.return();
			}
		} finally {
			if (_didIteratorError) {
				throw _iteratorError;
			}
		}
	}

	return Promise.all(result).then(function (datas) {
		return datas.reduce(function (prev, next) {
			return prev.concat(next);
		}, []);
	});
}

function scrap$6() {
	var promises = [];
	for (var offset = 0; offset < 1000; offset += 50) {
		promises.push(fetch('http://proxydb.net/?limit=50&offset=' + offset).then(cheerio()).then(function ($$$1) {
			if (!$$$1) return [];
			return $$$1('table > tbody > tr').map(function (i, element) {
				var url$$1 = $$$1(element).find('td > a').first().text().trim();
				var ip = /(\d+\.){3}\d+/.exec(url$$1)[0];
				var port = /\d+$/.exec(url$$1)[0];

				return { ip: ip, port: port };
			}).get();
		}));
	}
	return Promise.all(promises).then(function (values) {
		return values.reduce(function (prev, next) {
			return prev.concat(next);
		});
	}, []);
}

var proxyspy = createTextScraper('http://txt.proxyspy.net/proxy.txt');

//TODO: Better Text Scrapper

var scrapers = {
	'free-proxy-list.net': scrap,
	'gatherproxy.com': scrap$1,
	'hidemy.name': scrap$2,
	'hidester.com': scrap$3,
	'multiproxy.org': multiproxy,
	'nordvpn.com': scrap$4,
	'proxy24.blogspot.fr': scrap$5,
	'proxydb.net': scrap$6,
	'proxyspy.net': proxyspy
	//"spys.me": spys
};

var Lock = function () {
	function Lock(inner) {
		classCallCheck(this, Lock);

		this.inner = Promise.resolve(inner);
	}

	createClass(Lock, [{
		key: "get",
		value: function get$$1(callback) {
			var p = this.inner.then(function (inner) {
				var result = callback(inner);
				return Promise.resolve(result).then(function (result) {
					return { inner: inner, result: result };
				}, function (err) {
					return { inner: inner, err: err };
				});
			});
			this.inner = p.then(function (_ref) {
				var inner = _ref.inner;
				return inner;
			});
			return p.then(function (_ref2) {
				var result = _ref2.result,
				    err = _ref2.err;
				return err ? Promise.reject(err) : result;
			});
		}
	}]);
	return Lock;
}();

var log = debug('proxy-scraper');

var ProxyScraper = function () {
	function ProxyScraper() {
		var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
		    _ref$workerCount = _ref.workerCount,
		    workerCount = _ref$workerCount === undefined ? os.cpus().length : _ref$workerCount;

		classCallCheck(this, ProxyScraper);

		this._workers = [];
		for (var i = 0; i < workerCount; i++) {
			log('Spawning worker %d', i);
			var worker = child.fork(path.join(__dirname, './src/worker.js'), [i]);
			worker.on('error', function (error) {
				return console.error(error);
			});
			this._workers.push(new Lock(worker));
		}
	}

	createClass(ProxyScraper, [{
		key: 'getProxies',
		value: function getProxies(timeout) {
			var _this = this;

			return this.scrapProxies().then(function (proxies) {
				return _this.testProxies(timeout, proxies);
			});
		}
	}, {
		key: 'testProxies',
		value: function testProxies(timeout, proxies) {
			var _this2 = this;

			var stream$$1 = new stream.Readable({ objectMode: true });
			var proxiesCount = proxies.length;
			var queue = proxies.slice(0); //Clone it
			stream$$1._read = function () {
				var _loop = function _loop(worker) {
					var done = false;
					var run = function run() {
						if (queue.length) {
							var proxy = queue.pop();
							worker.get(function (worker) {
								var p = _this2._testProxy({
									url: 'http://example.com/',
									proxy: proxy.port == 443 ? 'https://' + proxy.ip : 'http://' + proxy.ip + ':' + proxy.port,
									timeout: timeout
								}, worker);
								return p;
							}).then(function (time) {
								done = true;
								proxy.time = time;
								log('Working proxy: %o', proxy);
								stream$$1.push(proxy);
							}).catch(function (e) {
								return null;
							}).then(function () {
								stream$$1.emit('progress', {
									length: proxiesCount,
									remaining: queue.length,
									percentage: (1 - queue.length / proxiesCount) * 100
								});
								return done ? null : run();
							});
						} else {
							stream$$1.push(null);
						}
					};
					run();
				};

				var _iteratorNormalCompletion = true;
				var _didIteratorError = false;
				var _iteratorError = undefined;

				try {
					for (var _iterator = _this2._workers[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
						var worker = _step.value;

						_loop(worker);
					}
				} catch (err) {
					_didIteratorError = true;
					_iteratorError = err;
				} finally {
					try {
						if (!_iteratorNormalCompletion && _iterator.return) {
							_iterator.return();
						}
					} finally {
						if (_didIteratorError) {
							throw _iteratorError;
						}
					}
				}
			};
			return stream$$1;
		}
	}, {
		key: '_testProxy',
		value: function _testProxy(proxy, worker) {
			worker.send(proxy);
			return new Promise(function (resolve, reject) {
				worker.once('message', function (data) {
					if (data.working) {
						resolve(data.time);
					} else {
						reject(data.error);
					}
				});
			});
		}
	}, {
		key: 'scrapProxies',
		value: function scrapProxies() {
			var proxies = [];
			log('Scrapers: %o', Object.keys(ProxyScraper.scrapers));

			var _loop2 = function _loop2(scraper) {
				proxies.push(scrapers[scraper]().then(function () {
					var proxies = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

					log('Found %d proxies from %s', proxies.length, scraper);
					proxies.forEach(function (proxy) {
						return proxy.source = scraper;
					});
					return proxies;
				}).catch(function (e) {
					log('Error while scraping proxies with %s\n%o', scraper, e);
					return [];
				}));
			};

			for (var scraper in ProxyScraper.scrapers) {
				_loop2(scraper);
			}
			return Promise.all(proxies).then(function (values) {
				return values.reduce(function (prev, next) {
					return prev.concat(next);
				});
			}, []);
		}
	}]);
	return ProxyScraper;
}();

ProxyScraper.scrapers = scrapers;

module.exports = ProxyScraper;
//# sourceMappingURL=0.12.js.map
